/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package es.rickyepoderi.jmx.servlet;

import javax.management.MBeanException;
import javax.management.Notification;
import javax.management.NotificationBroadcasterSupport;
import javax.management.modelmbean.ModelMBean;

/**
 * <p>Implementation for the Hello interface.</p>
 * 
 * @author ricky
 */
public class Hello extends NotificationBroadcasterSupport implements HelloMBean {

    private String message = null;
    private long namedHellos = 0;
    private long worldHellos = 0;
    
    /**
     * Default constructor. Message defaulted to "Hello" and counters to 0.
     */
    public Hello() {
        message = "Hello";
        namedHellos = 0;
        worldHellos = 0;
    }
    
    @Override
    public String getMessage() {
        return message;
    }

    @Override
    public void setMessage(String message) {
        this.message = message;
    }

    @Override
    public long getHellos() {
        return namedHellos + worldHellos;
    }

    @Override
    public long getWorldHellos() {
        return worldHellos;
    }

    @Override
    public long getNamedHellos() {
        return namedHellos;
    }
    
    synchronized private void incrementNamedHellos() {
        namedHellos++;
    }
    
    synchronized private void incrementWorldHellos() {
        worldHellos++;
    }
    
    @Override
    public String sayHello(String name) {
        if (name == null || name.isEmpty()) {
            name = "world";
            this.incrementWorldHellos();
        } else {
            this.incrementNamedHellos();
        }
        String txt = this.message + " " + name + "!!!";
        Notification n = new Notification("Hello", this, this.getHellos(), System.currentTimeMillis(), txt);
        this.sendNotification(n);
        return txt;
    }
    
    @Override
    synchronized public void reset() {
        message = "Hello";
        namedHellos = 0;
        worldHellos = 0;
    }
}
