/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package es.rickyepoderi.jmx.servlet;

/**
 * <p>Sample Managed Bean interface to say hello to the world or to a specific 
 * name. The bean manages the following attributes:</p>
 * 
 * <ul>
 * <li>message: The hello message to display (default "Hello")</li>
 * <li>Hellos: The total number of hellos sent by the application.</li>
 * <li>worldHellos: The number of hellos sent to the world.</li>
 * <li>namedHellos: The number of hellos sent to a specific name.</li>
 * </ul>
 * 
 * @author ricky
 */
public interface HelloMBean {
    
    /**
     * Getter for the greeting message.
     * 
     * @return The greeting message.
     */
    public String getMessage();
    
    /**
     * Setter for the greeting message.
     * 
     * @param message The new greeting message.
     */
    public void setMessage(String message);
    
    /**
     * Getter for the total hellos counter.
     * 
     * @return The number of hellos sent by the server.
     */
    public long getHellos();
    
    /**
     * Getter for the world hellos counter.
     * 
     * @return The number of hellos sent to the world.
     */
    public long getWorldHellos();
    
    /**
     * Getter for the named hellos counter.
     * 
     * @return The number of hellos sent to a specific person.
     */
    public long getNamedHellos();
    
    /**
     * Method that say hello to a name or to the world. If the name is null
     * or empty a world hello is returned, if a name is specified a named hello
     * is returned.
     * 
     * @param name The name to say hello or null
     * @return The hello message to that name or to the world
     */
    public String sayHello(String name);
    
    /**
     * Reset all the counters to 0 and the message to the default "Hello".
     */
    public void reset();
    
}
